#ifdef GL_ES
precision mediump float;
#endif
 
varying vec2 v_texCoord;

uniform float u_dH;
uniform float u_dS;
uniform float u_dL;
 
void main() {
    vec4 texColor = texture2D(CC_Texture0, v_texCoord);
    
	float r = texColor.r;
    float g = texColor.g;
    float b = texColor.b;
    float a = texColor.a;

    // convert rgb to hsl
    float h;
    float s;
    float l;
    {
        float max = max(max(r,g),b);
        float min = min(min(r,g),b);

        // ----h
		if(r == max){
			h = (g - b) / (max - min) * 60.0;
		}
		else if(max == g){
			h = 120.0 + (b - r) / (max - min) * 60.0;
		}
		else if(max == b){
			h = 240.0 + (r - g) / (max - min) * 60.0;
		}

		if(h < 0){
			h = h + 360.0;
		}

        // ----l
        l = max;

        // ----s
        s = (max - min) / max;
    }

    // (h,s,l)+(dH,dS,dL) -> (h,s,l)
	{
		h = h + u_dH;

		s = min(1.0, max(0.0,s + u_dS));

		l = l + u_dL;
	}

    // convert (h,s,l) to rgb and got final color
    vec4 finalColor;
    {
		if(s == 0){
			r = g = b = l;
		}
		else{
			h /= 60.0;
			
			int i = h;

			float f = h - i;
			float a1 = l * (1.0 - s);
			float b1 = l * (1.0 - s * f);
			float c1 = l * (1.0 - s * (1.0 - f));

			switch(i){
				case 0: r = l; g = c1; b = a1; break;
				case 1: r = b1; g = l; b = a1; break;
				case 2: r = a1; g = l; b = c1; break;
				case 3: r = a1; g = b1; b = l; break;
				case 4: r = c1; g = a1; b = l; break;
				case 5: r = l; g = a1; b = b1; break;
			}
		}
        finalColor=vec4(r, g, b, a);
    }
 
    // finalColor += vec4(u_dL, u_dL, u_dL, 0.0);
 
    gl_FragColor = finalColor;
}
